=== debian/changelog ===
percona-xtrabackup-24 (2.4.24-1) unstable; urgency=medium

  * Update to new upstream release Percona XtraBackup 2.4.24

 -- ubuntu-cloud-user <tomislav.plavcic@percona.com>  Tue, 07 Sep 2021 13:51:36 +0000
