## percona-xtrabackup-24 2.4.25

=== debian/changelog ===
percona-xtrabackup-24 (2.4.25-1) unstable; urgency=medium

  * Update to new upstream release Percona XtraBackup 2.4.25

 -- ubuntu-cloud-user <tomislav.plavcic@percona.com>  Tue, 19 Apr 2022 18:17:17 +0000
