## percona-xtrabackup-24 2.4.26

=== debian/changelog ===
percona-xtrabackup-24 (2.4.26-1) unstable; urgency=medium

  * Update to new upstream release Percona XtraBackup 2.4.26

 -- ubuntu-cloud-user <tomislav.plavcic@percona.com>  Tue, 03 May 2022 10:55:13 +0000
