## percona-xtrabackup-24 2.4.27

=== debian/changelog ===
percona-xtrabackup-24 (2.4.27-1) unstable; urgency=medium

  * Update to new upstream release Percona XtraBackup 2.4.27

 -- ubuntu-cloud-user <tomislav.plavcic@percona.com>  Thu, 01 Dec 2022 13:10:21 +0000
