## percona-xtrabackup-24 2.4.28

=== debian/changelog ===
percona-xtrabackup-24 (2.4.28-1) unstable; urgency=medium

  * Update to new upstream release Percona XtraBackup 2.4.28

 -- ubuntu-cloud-user <tomislav.plavcic@percona.com>  Thu, 23 Mar 2023 09:48:49 +0000
